"""
Carlos J Corrada Bravo
Este programa calcula el promedio de tiempo de ejecucion de cuatro algoritmos de ordenamiento
La variable maxValor define el valor maximo de los elementos de la lista
La variable largoLista define el largo de las listas a ordenar
La variable veces define las veces que se va a hacer el ordenamiento 
Al final se imprimen los promedios de cada algoritmo

Shellsort modificado por: Edward Garcia
Num. de est: 801-18-6162
"""
from random import randint
import time

def mergeSort(lista):
	# definan el algoritmo de ordenamiento mergesort
	return lista

def heapSort(lista):
	# definan el algoritmo de ordenamiento heapsort
	return lista

def quickSort(lista):
	# definan el algoritmo de ordenamiento quicksort
	return lista

def shellSort(lista):
	# definan el algoritmo de ordenamiento shellsort
	div = len(lista) / 2
	# verifica si no se puede dividir mas
	while div != 0:
	# dividir lista en sub listas
		for j in range(div):
			# hacer insertion sort en sub listas
			for x in range(div + j, len(lista), div):
				key = lista[x]
				pos = x - div
				while pos >= 0 and key < lista[pos]:
					lista[pos + div] = lista[pos]
					pos -= div
				lista[pos + div] = key
		div /= 2
	return lista


maxValor = 1000 	# define el valor maximo de los elementos de la lista
largoLista = 1000  # define el largo de las listas a ordenar
veces = 100 		# define las veces que se va a hacer el ordenamiento

acumulaMerge = 0 	# variable para acumular el tiempo de ejecucion del mergesort
acumulaHeap = 0 	# variable para acumular el tiempo de ejecucion del heapsort
acumulaQuick = 0 	# variable para acumular el tiempo de ejecucion del quicksort
acumulaShell = 0 	# variable para acumular el tiempo de ejecucion del shellsort

for i in range(veces):
	mergelista = [randint(0,maxValor) for r in range(largoLista)] # creamos una lista con valores al azar
	heaplista = list(mergelista)
	quicklista = list(mergelista)
	searchlista = list(mergelista)

	t1 = time.clock() 				# seteamos el tiempo al empezar
	mergeSort(mergelista) 				# ejecutamos el algoritmo mergeSort
	acumulaMerge += time.clock()-t1 	# acumulamos el tiempo de ejecucion
	
	t1 = time.clock()				# seteamos el tiempo al empezar
	heapSort(heaplista)					# ejecutamos el algoritmo heapSort
	acumulaHeap += time.clock()-t1 	# acumulamos el tiempo de ejecucion
	
	t1 = time.clock()				# seteamos el tiempo al empezar
	quickSort(quicklista)				# ejecutamos el algoritmo quickSort
	acumulaQuick += time.clock()-t1 	# acumulamos el tiempo de ejecucion
	
	t1 = time.clock()				# seteamos el tiempo al empezar
	shellSort(searchlista)				# ejecutamos el algoritmo shellSort
	acumulaShell += time.clock()-t1 	# acumulamos el tiempo de ejecucion

# imprimimos los resultados
print "Promedio de tiempo de ejecucion de " + str(veces) +" listas de largo " + str(largoLista)
print "MergeSort " + str(acumulaMerge/veces) + " segundos"
print "HeapSort " + str(acumulaHeap/veces) + " segundos"
print "QuickSort " + str(acumulaQuick/veces) + " segundos"
print "ShellSort " + str(acumulaShell/veces) + " segundos"